You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

138 lines
4.2 KiB

5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
  1. #!/bin/bash
  2. set -e
  3. exec 3>&1 # make stdout available as fd 3 for the result
  4. exec 1>&2 # redirect all output to stderr for logging
  5. echo "BUILD_ID: $BUILD_ID"
  6. echo "BUILD_NAME: $BUILD_NAME"
  7. echo "BUILD_JOB_NAME: $BUILD_JOB_NAME"
  8. echo "BUILD_PIPELINE_NAME: $BUILD_PIPELINE_NAME"
  9. # shellcheck disable=1090
  10. source "$(dirname $0)/common.sh"
  11. source=$1
  12. if [[ -z "$source" ]]; then
  13. echo "usage: $0 <path/to/source>"
  14. exit 1
  15. fi
  16. # for jq
  17. PATH=/usr/local/bin:$PATH
  18. payload=$(mktemp "$TMPDIR/rclone-resource-request.XXXXXX")
  19. cat > "$payload" <&0
  20. load_config "$payload"
  21. load_files "$payload"
  22. rclone_source_directory=$(jq -r '.params.source // ""' < "$payload")
  23. rclone_destinations=$(jq -r '.params.destination[]? | .dir // ""' < "$payload")
  24. if [[ -z "$rclone_source_directory" ]]; then
  25. echo "invalid source directory (missing source)"
  26. exit 1
  27. fi
  28. if [[ -z "$rclone_destinations" ]]; then
  29. echo "invalid destination (missing destination)"
  30. exit 1
  31. fi
  32. echo "Source directory: $rclone_source_directory"
  33. echo "Destinations:"
  34. jq -c '.params.destination[] | .dir' < "$payload"
  35. local_source_dir="${source}/${rclone_source_directory}"
  36. ls -alh "${local_source_dir}"
  37. echo "Generating SHA256"
  38. sha256_file="${TMPDIR}/rclone_source.sha256"
  39. touch "${sha256_file}"
  40. (find "${local_source_dir}" -type f -exec sha256sum {} \;) | cut -d ' ' -f1 | xargs echo >> "${sha256_file}"
  41. sha256=$(sha256sum "${sha256_file}" | cut -d' ' -f1)
  42. echo "sha256:${sha256}"
  43. # Source is always the same for each destination
  44. rclone_source="${local_source_dir}"
  45. echo "Source: ${rclone_source}"
  46. destinations=$(jq -r '.params.destination[] | @base64' < "$payload")
  47. echo "Using encoded destinations:"
  48. echo " ${destinations}"
  49. file_links=()
  50. for destination in $destinations; do
  51. _jq() {
  52. echo "${destination}" | base64 -d | jq -r "${1}"
  53. }
  54. rclone_destination=$(_jq '.dir')
  55. rclone_destination_subdir_file=$(_jq '.subdir // ""')
  56. rclone_dedupe=$(_jq '.dedupe // "false"')
  57. rclone_dedupe_mode=$(_jq '.dedupeMode // "newest"')
  58. rclone_args=$(_jq '.args // [] | join(" ")')
  59. rclone_link=$(_jq '.link // "false"')
  60. rclone_link_find_filter=$(_jq '.linkFilter // "-maxdepth 1 -type f"')
  61. echo "Destination: $rclone_destination"
  62. echo "Destination subdir file: ${rclone_destination_subdir_file}"
  63. echo "Run dedupe: ${rclone_dedupe}"
  64. echo "Dedupe mode: ${rclone_dedupe_mode}"
  65. echo "Additonal args: ${rclone_args}"
  66. echo "Generate link: ${rclone_link}"
  67. echo "Link find filter: ${rclone_link_find_filter}"
  68. rclone_destination_subdir=""
  69. if [ -n "$rclone_destination_subdir_file" ]; then
  70. echo "Looking in ${source}/${rclone_destination_subdir_file} for subdir to use"
  71. rclone_destination_subdir=$(head -n 1 < "${source}/${rclone_destination_subdir_file}")
  72. fi
  73. rclone_target="${rclone_destination}/${rclone_destination_subdir}"
  74. echo "Target: ${rclone_target}"
  75. # shellcheck disable=2086
  76. rclone copy "${rclone_source}" "${rclone_target}" --size-only --progress --stats=2s ${rclone_args}
  77. if [[ "$rclone_dedupe" == "true" ]]; then
  78. echo "Running Dedupe for: ${rclone_target}"
  79. # shellcheck disable=2086
  80. rclone dedupe --dedupe-mode "${rclone_dedupe_mode}" "${rclone_target}" --progress --stats=2s ${rclone_args}
  81. fi
  82. if [[ "${rclone_link}" == "true" ]]; then
  83. # shellcheck disable=2086
  84. filesToLink=$(find "${rclone_source}" ${rclone_link_find_filter})
  85. echo "Files to link:"
  86. echo "${filesToLink}"
  87. for file in ${filesToLink}; do
  88. remote_file=${file#"$rclone_source/"}
  89. rclone_target_file="${rclone_target}${remote_file}"
  90. echo "Generating Link for: ${rclone_target_file}"
  91. file_link=$(rclone link "${rclone_target_file}")
  92. file_links+=( "${rclone_target_file}" "${file_link}" )
  93. done
  94. fi
  95. echo "rclone job complete for ${rclone_source} -> ${rclone_target}"
  96. done
  97. if (( ${#file_links[@]} )); then
  98. echo "File Links:" "${file_links[@]}"
  99. # shellcheck disable=2068
  100. metadata=$(printf '{"name": "%s", "value": "%s"},' ${file_links[@]})
  101. metadata=${metadata::-1}
  102. links_json=$( echo -n "{\"links\":[${metadata}]}" | jq -r . )
  103. echo "$links_json" > "${TMPDIR}/.rclone_links"
  104. cat "${TMPDIR}/.rclone_links"
  105. fi
  106. jq -n "{
  107. version: {
  108. build: $( echo -n "${BUILD_ID}" | jq -R .),
  109. digest: $( echo -n "sha256:$sha256" | jq -R . )
  110. }
  111. }" >&3